// test to create an option menu
// written by Robert Gasch (Robert_Gasch@peoplesoft.com)
// last modified: 10AUG1999: updated for gcc-2.95

#include <string.h>
#include <gtk--.h>
#include <gtk/gtk.h>


class testoptmenu : public Gtk_Dialog
	{
	public: 
					testoptmenu (char *title=NULL, 
						char *messagage=NULL);
					~testoptmenu (); 
		virtual void		buildDialogWindow ();

	protected: 	
		void			cb1 ();
		void			cb2 ();
		void			fillActionArea ();
		void 			buttonCallbackOK ();
		void 			buttonCallbackApply ();
		void 			buttonCallbackCancel ();
		gint			delete_event_impl (GdkEventAny *e);


		Gtk_Button		d_buttonOK, 
					d_buttonApply, 
					d_buttonCancel;

		char			*d_title,
					*d_message;

	private:
		Gtk_HBox		*d_defaultHBox;
	};



testoptmenu::testoptmenu(char *title, char *message)
	      : Gtk_Dialog (),
		d_buttonOK ("OK"),
		d_buttonApply ("Apply"),
		d_buttonCancel ("Cancel")
{
	char 		*s;

	if (title)
		s = title;
	else
		s = "testoptmenu Window";

	d_title = strdup (s);
	d_message = message;

	this->set_position (GTK_WIN_POS_MOUSE);
}


testoptmenu::~testoptmenu()
{
	if (d_title) 
		delete d_title;
}


void testoptmenu::buildDialogWindow ()
{
	this->set_usize (300, 120);
	this->set_title (d_title);

	this->get_vbox()->set_border_width (2);

	fillActionArea ();

	this->show ();
}


void testoptmenu::fillActionArea ()
{
	// create new hbox and add buttons to it
	connect_to_method (d_buttonOK.clicked, this, &testoptmenu::buttonCallbackOK);
	this->get_action_area()->pack_start (d_buttonOK, TRUE, TRUE, 0);
	d_buttonOK.show ();

	connect_to_method (d_buttonApply.clicked, this, &testoptmenu::buttonCallbackApply);
	this->get_action_area()->pack_start (d_buttonApply, TRUE, TRUE, 0);
	d_buttonApply.show ();

	connect_to_method (d_buttonCancel.clicked, this, &testoptmenu::buttonCallbackCancel);
	this->get_action_area()->pack_start (d_buttonCancel, TRUE, TRUE, 0);
	d_buttonCancel.show ();
}


void testoptmenu::cb1()
{
	printf ("Callback 1\n");
	fflush (stdout);
}


void testoptmenu::cb2()
{
	printf ("Callback 2\n");
	fflush (stdout);
}

void testoptmenu::buttonCallbackOK ()
{
	printf ("testoptmenu: Default Callback OK\n");
        //printf ("%s\n", d_colormapMenu.get_active());
}


void testoptmenu::buttonCallbackApply ()
{
}


void testoptmenu::buttonCallbackCancel ()
{
	this->hide ();
	exit (0);
}


gint testoptmenu::delete_event_impl(GdkEventAny *)
{
	this->hide ();
	return (0);
}


int main (int argc, char *argv[])
{
	Gtk_Main	gtkMain (&argc, &argv);
	testoptmenu	*testDialog;

	testDialog = new testoptmenu ("Default Title", "Default Message");
	testDialog->buildDialogWindow ();
	testDialog->show ();
	gtkMain.run ();
}

